Loading...
Searching...
No Matches
itk::RSGDEachParameterApartOptimizer Class Reference
Components » Optimizers

`#include <itkRSGDEachParameterApartOptimizer.h>`

## Detailed Description

An optimizer based on gradient descent.

This class is almost a copy of the normal itk::RegularStepGradientDescentOptimizer. The difference is that each parameter has its own step length, whereas the normal RSGD has one step length that is used for all parameters.

This could cause inaccuracies, if, for example, parameter 1, 2 and 3 are already close to the optimum, but parameter 4 not yet. The average stepsize is halved then, so parameter 4 will not have time to reach its optimum (in a worst case scenario).

The RSGDEachParameterApart stops only if ALL steplenghts are smaller than the MinimumStepSize given in the parameter file!

Note that this is a quite experimental optimizer, currently only used for some specific tests.

See also
  RSGDEachParameterApart

Definition at line 53 of file itkRSGDEachParameterApartOptimizer.h.

Inheritance diagram for itk::RSGDEachParameterApartOptimizer:
[legend]

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | CostFunctionPointer = CostFunctionType::Pointer
using | Pointer = SmartPointer<Self>
using | Self = RSGDEachParameterApartOptimizer
using | Superclass = RSGDEachParameterApartBaseOptimizer
Public Types inherited from itk::RSGDEachParameterApartBaseOptimizer
using | ConstPointer = SmartPointer<const Self>
using | Pointer = SmartPointer<Self>
using | Self = RSGDEachParameterApartBaseOptimizer
enum | StopConditionType { GradientMagnitudeTolerance = 1 , StepTooSmall , ImageNotAvailable , SamplesNotAvailable , MaximumNumberOfIterations , MetricError }
using | Superclass = SingleValuedNonLinearOptimizer

## Public Member Functions

virtual const char * | GetClassName () const
| ITK_DISALLOW_COPY_AND_MOVE (RSGDEachParameterApartOptimizer)
Public Member Functions inherited from itk::RSGDEachParameterApartBaseOptimizer
virtual unsigned long | GetCurrentIteration () const
virtual double | GetCurrentStepLength () const
virtual const DerivativeType & | GetCurrentStepLengths ()
virtual const DerivativeType & | GetGradient ()
virtual double | GetGradientMagnitude () const
virtual double | GetGradientMagnitudeTolerance () const
virtual bool | GetMaximize () const
virtual double | GetMaximumStepLength () const
bool | GetMinimize () const
virtual double | GetMinimumStepLength () const
virtual unsigned long | GetNumberOfIterations () const
virtual StopConditionType | GetStopCondition () const
virtual MeasureType | GetValue () const
| ITK_DISALLOW_COPY_AND_MOVE (RSGDEachParameterApartBaseOptimizer)
virtual void | MaximizeOff ()
virtual void | MaximizeOn ()
void | MinimizeOff ()
void | MinimizeOn ()
void | ResumeOptimization ()
virtual void | SetGradientMagnitudeTolerance (double _arg)
virtual void | SetMaximize (bool _arg)
virtual void | SetMaximumStepLength (double _arg)
void | SetMinimize (bool v)
virtual void | SetMinimumStepLength (double _arg)
virtual void | SetNumberOfIterations (unsigned long _arg)
void | StartOptimization () override
void | StopOptimization ()

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from itk::RSGDEachParameterApartBaseOptimizer
static Pointer | New ()

## Protected Member Functions

| RSGDEachParameterApartOptimizer ()=default
void | StepAlongGradient (const DerivativeType &factor, const DerivativeType &transformedGradient) override
| ~RSGDEachParameterApartOptimizer () override=default
Protected Member Functions inherited from itk::RSGDEachParameterApartBaseOptimizer
virtual void | AdvanceOneStep ()
void | PrintSelf (std::ostream &os, Indent indent) const override
| RSGDEachParameterApartBaseOptimizer ()
| ~RSGDEachParameterApartBaseOptimizer () override=default

## Member Typedef Documentation

## ConstPointer

using itk::RSGDEachParameterApartOptimizer::ConstPointer = SmartPointer<const Self>

Definition at line 62 of file itkRSGDEachParameterApartOptimizer.h.

## CostFunctionPointer

using itk::RSGDEachParameterApartOptimizer::CostFunctionPointer = CostFunctionType::Pointer

Definition at line 72 of file itkRSGDEachParameterApartOptimizer.h.

## Pointer

using itk::RSGDEachParameterApartOptimizer::Pointer = SmartPointer<Self>

Definition at line 61 of file itkRSGDEachParameterApartOptimizer.h.

## Self

using itk::RSGDEachParameterApartOptimizer::Self = RSGDEachParameterApartOptimizer

Standard class typedefs.

Definition at line 59 of file itkRSGDEachParameterApartOptimizer.h.

## Superclass

using itk::RSGDEachParameterApartOptimizer::Superclass = RSGDEachParameterApartBaseOptimizer

Definition at line 60 of file itkRSGDEachParameterApartOptimizer.h.

## Constructor & Destructor Documentation

## RSGDEachParameterApartOptimizer()

itk::RSGDEachParameterApartOptimizer::RSGDEachParameterApartOptimizer | ( |  | ) |

protected default

## ~RSGDEachParameterApartOptimizer()

itk::RSGDEachParameterApartOptimizer::~RSGDEachParameterApartOptimizer | ( |  | ) |

override protected default

## Member Function Documentation

## GetClassName()

virtual const char * itk::RSGDEachParameterApartOptimizer::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::RSGDEachParameterApartBaseOptimizer.

Reimplemented in elastix::RSGDEachParameterApart< TElastix >.

## ITK_DISALLOW_COPY_AND_MOVE()

itk::RSGDEachParameterApartOptimizer::ITK_DISALLOW_COPY_AND_MOVE | ( | RSGDEachParameterApartOptimizer |  | ) |

## New()

Pointer itk::RSGDEachParameterApartOptimizer::New | ( |  | ) |

static

Method for creation through the object factory.

## StepAlongGradient()

void itk::RSGDEachParameterApartOptimizer::StepAlongGradient | ( | const DerivativeType & | factor,
|  | const DerivativeType & | transformedGradient )

override protected virtual

Advance one step along the corrected gradient taking into account the steplengths represented by the factor array. This method is invoked by AdvanceOneStep. It is expected to be overrided by optimization methods in non-vector spaces

See also
  AdvanceOneStep

Reimplemented from itk::RSGDEachParameterApartBaseOptimizer.

Generated on 1768596610 for elastix by 1.15.0 |